<!DOCTYPE html>
<html lang="en">
  <head>
    <title>Task 520 post lists</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <link
      rel="stylesheet"
      href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css"
    />
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  </head>
  <body>
    <div class="container">
      <div class="text-center my-4">
        <h3 class="text-info">
          Danh sách các bình luận (comment) của bài viết
        </h3>
      </div>
      <div class="row form-group">
        <div class="col-sm-2">
          <label class="form-control text-dark">
            Điền post id:
          </label>
        </div>
        <div class="col-sm-6">
          <input
            type="text"
            class="form-control"
            id="inp-comment-id"
            placeholder="…điền post id, ví dụ 2, 3 …."
          />
        </div>
        <div class="col-sm-4">
          <button class="btn btn-info form-control" id="btn-get-comment-posts">
            Lấy danh sách bình luận của bài viết
          </button>
        </div>
      </div>
      <table
        class="table table-bordered table-striped table-hover"
        id="tbl-comment-posts"
      >
        <thead class="text-center">
          <tr>
            <th>id</th>
            <th>Post id</th>
            <th>Email</th>
            <th>Name</th>
            <th>Body</th>
            <th>Action</th>
          </tr>
        </thead>
        <tbody>
          
        </tbody>
      </table>
    </div>
    <script>
      "use strict";

      /*** REGION 1 - Global variables - Vùng khai báo hằng số, tham số TOÀN CỤC */
      const gCOL_POSTID = 0;
      const gCOL_POSTTITLE = 1;
      const gCOL_POSTBODY = 2;
      const gCOL_ACTION = 3;
      const gBASE_URL = "https://jsonplaceholder.typicode.com";

      var vInputCmtID = $("#inp-comment-id");

      /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
      $(document).ready(function () {
        //gán event handler cho nút
        $("#btn-get-comment-posts").click(onBtnGetCmtByPostIDClick);
      });

      /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
      function onBtnGetCmtByPostIDClick() {
        "use strict";
        var vCmtIDPost = { commmentId: 0 };
        //b1: thu thập dữ liệu
        readData(vCmtIDPost);
        //kiểm tra dữ liệu
        var vIsCheck = validateCommentId(vCmtIDPost);
        if (vIsCheck) {
          //3. gọi server
          callSeverByGetAjax(vCmtIDPost);
        }
      }

      //hàm xử lý button detail
      function onBtnDetailClick(paramObj) {
        "use strict";
        console.log(
          "%cDetail button click. Sự kiện Click là: ....",
          "color:orange"
        );
        var vButtonHidden = paramObj.currentTarget;
        const vFORM_TO_OPEN = "task520postdetail.html"; //đây là form sẽ mở
        var vUrlToOpenPage =
          vFORM_TO_OPEN + "?" + "id=" + $(vButtonHidden).data("id");
        window.location.href = vUrlToOpenPage;
      }

      /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
      function callSeverByGetAjax(paramObj) {
        var vAPI_URL =
          gBASE_URL + "/posts/" + paramObj.commmentId + "/comments/";
        $.ajax({
          url: vAPI_URL,
          type: "GET",
          dataType: "json",
          success: function (responseObject) {
            console.log(JSON.stringify(responseObject)); //response text
            //4 xử lý hiện thị
            loadTableCmtPost(responseObject); // responseObject là array các posts
          },
          error: function (ajaxContext) {
            alert(ajaxContext.responseText);
          },
        });
      }
      //đọc dữ liệu
      function readData(paramObj) {
        paramObj.commmentId = parseInt(vInputCmtID.val().trim());
      }

      //hàm kiểm tra dữ liệu nhập vào input
      function validateCommentId(paramObj) {
        if (isNaN(paramObj.commmentId)) {
          alert("Comment id không được để trống, nếu bạn định tìm!");
          return false;
        }
        return true;
      }
//dữ liệu lên table
        function loadTableCmtPost(paramPost) {
        "use strict";
        //xóa dữ liệu table
        resetDataTable();
        //đổ data 
        for (var bI = 0; bI < paramPost.length; bI++) {
          var bNewRow = $("<tr>").appendTo("#tbl-comment-posts tbody");
          var bArrObj = paramPost[bI];
          $("<td>").html(bArrObj.id).appendTo(bNewRow);
          $("<td>").html(bArrObj.postId).appendTo(bNewRow);
          $("<td>").html(bArrObj.email).appendTo(bNewRow);
          $("<td>").html(bArrObj.name).appendTo(bNewRow);
          $("<td>").html(bArrObj.body).appendTo(bNewRow);
          var bColAction = $("<td>").addClass("btn-group").appendTo(bNewRow);
          var bNewButton = $("<button>", { html: "Chi Tiết" })
            .addClass("btn btn-info")
            .data("id", bArrObj.id)
            .appendTo(bColAction);

          
          bNewButton.click(onBtnDetailClick);
        }
      }
      //hàm xóa dữ liệu table
      function resetDataTable() {
        $("#tbl-comment-posts tbody").html("");
      }
    </script>
  </body>
</html>
